__UNICODE__ equ 1

.586p
.model flat,stdcall
option casemap:none
.xmm
.mmx

RegisterControls    PROTO   :DWORD,:DWORD
StaticExProc        PROTO   :DWORD,:DWORD,:DWORD,:DWORD
ChevronProc         PROTO   :DWORD,:DWORD,:DWORD,:DWORD
DrawChev            PROTO   :DWORD
ConvertToASCII      PROTO   :DWORD,:DWORD
DebugThread         PROTO   :DWORD

include c:\masm32\include\windows.inc
include c:\masm32\include\kernel32.inc
include c:\masm32\include\user32.inc
include c:\masm32\include\gdi32.inc
include .\ecl.inc

include c:\masm32\macros\macros.asm

includelib c:\masm32\lib\kernel32.lib
includelib c:\masm32\lib\user32.lib
includelib c:\masm32\lib\gdi32.lib

.const

.data
hInstance   dd      ?
stxnsc  NM_STXHEIGHTCHANGED     <>
TIMER   dd      OFF
UCSTR       StaticExClass,"STATICEX",0   
wcStaticEx  WNDCLASS    <CS_HREDRAW+CS_VREDRAW,offset StaticExProc,0,\
                        sizeof EXTRA,0,0,0,COLOR_WINDOW,0,\
                        offset StaticExClass>
; +++ Sub-Controls +++

UCSTR       ChevronClass,"CHEVRON",0
wcChevron   WNDCLASS    <CS_HREDRAW+CS_VREDRAW,offset ChevronProc,0,\
                        sizeof EXTRA,0,0,0,COLOR_WINDOW,0,offset ChevronClass>

.code
RegisterControls    PROC    hInst:DWORD,dwControls:DWORD
    .if     dwControls&&IEC_STATIC_CLASS
        push    hInst
        pop     wcStaticEx.hInstance
        sub     esp,4
        pop     wcChevron.hInstance
        invoke  RegisterClass,addr wcStaticEx
        invoke  RegisterClass,addr wcChevron
    .endif
    ret

RegisterControls    endp
invoke  StaticExProc,0,0,0,0
invoke  ChevronProc,0,0,0,0
StaticExProc    PROC    uses esi edi hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    local   BkMode:DWORD
    
    .if     uMsg==WM_CREATE
        invoke  LocalAlloc,LPTR,sizeof STEXSTRUCT
        mov     edi,eax
        push    hWnd
        pop     [edi.STEXSTRUCT].hWnd
        invoke  SetWindowLong,hWnd,EXTRA.hMem,eax
        push    edi
        mov     esi,lParam
        mov     ecx,sizeof CREATESTRUCT/4
        cld
loop_1:
        movsd
        dec     ecx
        jcxz    end_loop_1
        jmp     loop_1
end_loop_1:
        pop     edi
        mov     esi,lParam

        assume  esi:PTR CREATESTRUCT
        assume  edi:PTR STEXSTRUCT
        
        invoke  GetClientRect,[esi].hWndParent,addr [edi].WndRect
        test    [esi].style,STXS_BOTTOM
        jp      align_wnd_to_bottom
        test    [esi].style,STXS_TOP
        jz      proceed_01            
        cmp     [esi].y,0
        ja      align_to_top
        jmp     proceed_01
align_to_top:
        push    esi
        push    edi
        invoke  MoveWindow,hWnd,0,0,[edi].WndRect.right,[esi].ly,TRUE
        jmp     proceed_01
align_wnd_to_bottom:
        mov     eax,[esi].ly
        sub     [edi].WndRect.bottom,eax
        push    esi
        push    edi
        invoke  MoveWindow,hWnd,0,[edi].WndRect.bottom,[edi].WndRect.right,[esi].ly,TRUE
        jmp     proceed_01
proceed_01:
        pop     edi
        pop     esi
        .if     [esi].lpszName!=0
            push    [esi].lpszName
            pop     [edi].acstr.lpText
            mov     [edi].dwAction,ACT_TEXT
            invoke  SendMessage,hWnd,STXM_ADDCONTENT,0,addr [edi].acstr
        .endif            
            push    [esi].x
            pop     [edi].ChevStruct.cstr.x
            push    [esi].y
            test    [esi].style,STXS_BOTTOM
            jp      bottom_aligned
            pop     [edi].ChevStruct.cstr.y
            add     [edi].ChevStruct.cstr.y,2
            jmp     proceed_0
bottom_aligned:
            add     esp,4
            mov     eax,[esi].ly
            add     eax,[esi].y
            sub     eax,6
            mov     [edi].ChevStruct.cstr.y,eax
proceed_0:
            mov     [edi].rect.left,0
            mov     [edi].rect.top,0
            push    [esi].lx
            pop     [edi].rect.right
            push    [esi].ly
            pop     [edi].rect.bottom
            
            mov     ebx,[esi].style
            mov     eax,[esi].lx
            add     eax,[esi].x
            mov     [edi].rect.right,eax
            mov     eax,[esi].ly
            add     eax,[esi].y
            mov     [edi].rect.bottom,eax
            add     [edi].ChevStruct.cstr.x,2
            invoke  GetProcessHeap
            push    eax
            invoke  HeapAlloc,eax,HEAP_ZERO_MEMORY,sizeof CREATESTRUCTEX
            mov     [eax.CREATESTRUCTEX].hMem,eax
            push    hWnd
            pop     [eax.CREATESTRUCTEX].hWndRef
            pop     ebx
            mov     [eax.CREATESTRUCTEX].hHeap,ebx
            xor     ebx,WS_VISIBLE
            invoke  CreateWindowEx,NULL,addr ChevronClass,0,ebx,\
                         [edi].ChevStruct.cstr.x,[edi].ChevStruct.cstr.y,7,4,\
                         [edi].cstr.hWndParent,0,[esi].hInstance,eax
            mov     [edi].ChevStruct.hCh,eax

            assume  esi:NOTHING
            assume  edi:NOTHING
                                                      
    .elseif uMsg==STXM_ADDCONTENT

        mov     edi,lParam
        assume  edi:PTR ACSTRUCT
        invoke  GetWindowLong,hWnd,EXTRA.hMem
        mov     esi,eax
        assume  esi:PTR STEXSTRUCT
        mov     eax,[esi].dwAction
        .if     [edi].hIcon!=0
            or  eax,ACT_ICON
            push    [edi].hIcon
            pop     [esi].acstr.hIcon
        .else
            xor     eax,ACT_ICON
            .if [edi].hBitmap!=0
                or      eax,ACT_BITMAP
                push    [edi].hBitmap
                pop     [esi].acstr.hBitmap
            .else
                xor     eax,ACT_BITMAP
            .endif                           
        .endif
        .if [edi].lpText!=0
            or  eax,ACT_TEXT
            push    [edi].lpText
            pop     [esi].acstr.lpText
        .else
            xor     eax,ACT_TEXT
        .endif            
        mov     [esi].dwAction,eax
 ;         test    eax,ACT_SHOW
 ;         jnz     skip_show
        invoke  ShowWindow,[esi].ChevStruct.hCh,SW_HIDE
        invoke  ShowWindow,hWnd,SW_SHOW
        or      [esi].dwAction,ACT_SHOW
skip_show:        
        invoke  InvalidateRect,hWnd,addr [esi].rect,TRUE
        .if     TIMER==ON
            invoke  KillTimer,hWnd,100
        .endif                        
        invoke  SetTimer,hWnd,0100,2000,addr StaticExProc        
        mov     TIMER,ON
        
        assume  esi:NOTHING
        assume  edi:NOTHING
        
    .elseif uMsg==WM_PAINT

        invoke  GetWindowLong,hWnd,EXTRA.hMem
        mov     esi,eax
        assume  esi:PTR STEXSTRUCT
        lea     edi,[esi].ps
        assume  edi:PTR PAINTSTRUCT
        invoke  GetBkMode,[edi].hdc
        mov     BkMode,eax
        invoke  BeginPaint,hWnd,edi
        invoke  CreateCompatibleDC,[edi].hdc
        mov     [esi].hMemDC,eax
        test    [esi].dwAction,ACT_ICON
        jz      no_icon
        invoke  DrawIconEx,[edi].hdc,[edi].rcPaint.left,[edi].rcPaint.top,[esi].acstr.hIcon,\
                    18,18,0,0,DI_NORMAL
        add     [edi].rcPaint.left,20
        jmp     test_4_text
no_icon:        
        test    [esi].dwAction,ACT_BITMAP
        jz      test_4_text
        invoke  SelectObject,[esi].hMemDC,[esi].acstr.hBitmap
        invoke  DeleteObject,eax
        invoke  GetBitmapDimensionEx,[esi].acstr.hBitmap,addr [esi]._size
        invoke  StretchBlt,[edi].hdc,[edi].rcPaint.top,[edi].rcPaint.top,18,18,\
                    [esi].hMemDC,0,0,[esi]._size.x,[esi]._size.y,SRCCOPY
        add     [edi].rcPaint.left,20
test_4_text:
        test    [esi].dwAction,DEF_FONT
        jz      do_text
        invoke  SelectObject,[edi].hdc,[esi].hFont
        invoke  DeleteObject,eax
        test    [esi].dwAction,ACT_TEXT
        jz      no_text
do_text:        
        invoke  SetBkMode,[edi].hdc,TRANSPARENT
        invoke  DrawText,[edi].hdc,[esi].acstr.lpText,-1,addr [edi].rcPaint,DT_LEFT
no_text:
        invoke  DeleteDC,[esi].hMemDC
        invoke  SetBkMode,[edi].hdc,BkMode
        invoke  EndPaint,hWnd,edi
        or      [esi].dwAction,ACT_SHOW
        assume  edi:NOTHING      
        assume  esi:NOTHING 
        
    .elseif uMsg==WM_TIMER
        .if     wParam==0100
            invoke  GetWindowLong,hWnd,EXTRA.hMem
            mov     esi,eax
            assume  esi:PTR STEXSTRUCT
            xor     [esi].dwAction,ACT_SHOW
            invoke  ShowWindow,hWnd,SW_HIDE
            invoke  ShowWindow,[esi].ChevStruct.hCh,SW_SHOW
            invoke  InvalidateRect,[esi].ChevStruct.hCh,addr [esi].ChevStruct.rect,TRUE
            mov     stxnsc.Height,8
            or      stxnsc.hdr.code,STXN_HEIGHTCHANGED
            invoke  GetParent,hWnd
            mov     eax,[esi].cstr.hWndParent
            invoke  SendMessage,eax,WM_NOTIFY,0,addr stxnsc
            invoke  KillTimer,hWnd,0100
            mov     TIMER,OFF
            xor     [esi].dwAction,ACT_SHOW
        .endif        
        ASSUME  esi:NOTHING
    .elseif uMsg==WM_SETFONT
        invoke  GetWindowLong,hWnd,EXTRA.hMem
        mov     edi,eax
        push    wParam
        pop     [edi.STEXSTRUCT].hFont
        or      [edi.STEXSTRUCT].dwAction,DEF_FONT
        .if     lParam==TRUE
            invoke  InvalidateRect,hWnd,addr [edi.STEXSTRUCT].rect,TRUE
        .endif
                    
   .elseif uMsg==WM_DESTROY
        invoke  GetWindowLong,hWnd,EXTRA.hMem
        invoke  LocalFree,eax
               
    .else
        invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
        ret       
    .endif
    mov     eax,0
    ret        
        
StaticExProc    endp

ChevronProc     PROC   uses esi edi hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    
    .if     uMsg==WM_CREATE

        mov     esi,lParam
        mov     esi,[esi.CREATESTRUCTEX].cstr.lpCreateParams
        assume  esi:PTR CREATESTRUCTEX
        invoke  GetWindowLong,[esi].hWndRef,EXTRA.hMem
        mov     edi,eax
        assume  edi:PTR STEXSTRUCT
        invoke  SetWindowLong,hWnd,EXTRA.hMem,edi
        lea     edi,[edi].ChevStruct.cstr
        mov     ecx,sizeof CREATESTRUCT/4
        push    edi        
        cld
copy_loop:
        movsd
        dec     ecx
        jcxz    end_copy_loop
        jmp     copy_loop
end_copy_loop:     
        pop     edi
        mov     esi,lParam
        mov     esi,[esi.CREATESTRUCT].lpCreateParams
        assume  esi:PTR CREATESTRUCTEX
        push    [esi].cstr.x        
        pop     [edi].ChevStruct.rect.left
        mov     eax,[esi].cstr.lx
        add     eax,[esi].cstr.x
        mov     [edi].ChevStruct.rect.right,eax
        push    [esi].cstr.y
        pop     [edi].ChevStruct.rect.top
        mov     eax,[esi].cstr.ly
        add     eax,[esi].cstr.y
        mov     [edi].ChevStruct.rect.bottom,eax
        test    [esi].cstr.style,STXS_BOTTOM
        jp      bottom_aligned
        invoke  CreatePolygonRgn,addr [edi].ChevStruct.chPtsTop,3,ALTERNATE
        jmp     proceed_1
bottom_aligned:        
        invoke  CreatePolygonRgn,addr [edi].ChevStruct.chPtsBottom,3,ALTERNATE
proceed_1:        
        mov     [edi].ChevStruct.chRgn,eax
        invoke  GetDC,hWnd
        mov     [edi].hDC,eax
        invoke  SelectObject,[edi].hDC,[edi].ChevStruct.chRgn
        invoke  DeleteObject,eax
        invoke  ReleaseDC,hWnd,[edi].hDC
        invoke  HeapFree,[esi].hHeap,0,[esi].hMem

        ASSUME  esi:NOTHING
        ASSUME  edi:NOTHING
        
    .elseif uMsg==WM_PAINT

        invoke  GetWindowLong,hWnd,EXTRA.hMem
        mov     esi,eax
        assume  esi:PTR STEXSTRUCT
        lea     edi,[esi].ps
        invoke  BeginPaint,hWnd,edi
        test    [esi].cstr.style,STXS_BOTTOM
        jp      bottom_aligned_2 
        invoke  DrawChev,TOP_ALIGN
        jmp     end_it        
bottom_aligned_2:        
        invoke  DrawChev,BOTTOM_ALIGN
end_it:        
        invoke  EndPaint,hWnd,edi

        assume  esi:NOTHING
        assume  edi:NOTHING
        
    .elseif uMsg==WM_MOUSEMOVE
        invoke  GetWindowLong,hWnd,EXTRA.hMem
        mov     esi,eax
        assume  esi:PTR STEXSTRUCT
        invoke  ShowWindow,[esi].hWnd,SW_SHOW
        invoke  ShowWindow,hWnd,SW_HIDE
        invoke  InvalidateRect,[esi].hWnd,addr [esi].rect,TRUE
        invoke  SetTimer,[esi].hWnd,0100,2000,addr StaticExProc
        mov     stxnsc.hdr.code,STXN_HEIGHTCHANGED
        push    [esi].cstr.ly
        pop     stxnsc.Height
        invoke  GetParent,hWnd
        mov     eax,[esi].cstr.hWndParent
        invoke  SendMessage,eax,WM_NOTIFY,0,addr stxnsc
        or      [esi].dwAction,ACT_SHOW
        assume  esi:NOTHING
        
    .else
        invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
        ret
    .endif
    xor     eax,eax        
    ret
    
ChevronProc     endp

DrawChev    PROC    DrawHow:DWORD

    assume  edi:PTR PAINTSTRUCT
    
    .if     DrawHow==TOP_ALIGN
        invoke  MoveToEx,[edi].hdc,0,0,0
        invoke  CreatePen,PS_SOLID,1,0ffffffh
        invoke  SelectObject,[edi].hdc,eax
        invoke  DeleteObject,eax
        invoke  LineTo,[edi].hdc,6,0
        invoke  LineTo,[edi].hdc,3,3       
        invoke  CreatePen,PS_SOLID,1,0
        invoke  SelectObject,[edi].hdc,eax
        invoke  DeleteObject,eax
        invoke  LineTo,[edi].hdc,0,0 
     .elseif DrawHow==BOTTOM_ALIGN
        invoke  MoveToEx,[edi].hdc,3,0,0
        invoke  CreatePen,PS_SOLID,1,0ffffffh
        invoke  SelectObject,[edi].hdc,eax
        invoke  DeleteObject,eax
        invoke  LineTo,[edi].hdc,6,3
        invoke  LineTo,[edi].hdc,0,3
        invoke  CreatePen,PS_SOLID,1,0
        invoke  SelectObject,[edi].hdc,eax
        invoke  DeleteObject,eax
        invoke  LineTo,[edi].hdc,3,0        
    .endif
    ret

DrawChev    endp

end    